-- ModMagicNumbersFileAdd( "data/magic_numbers_armory.xml" ) 

-- ModLuaFileAppend("mods/nightmare/files/biome_map.lua", "data/scripts/biomes/biome_map_armory.lua")
-- ModLuaFileAppend("data/scripts/newgame_plus.lua", "data/scripts/biomes/ngplus_commonifier.lua")

-- local function get_average( t )
  -- local sum, count = 0, 0
  -- for k,v in pairs(t) do
    -- if type(v) == 'number' then
      -- sum = sum + v
      -- count = count + 1
    -- end
  -- end
  -- return (sum / count)
-- end

-- local function standardDeviation( t )
    -- local m, vm, result
    -- local sum, count = 0, 0
  -- m = get_average( t )
  -- for k,v in pairs(t) do
    -- if type(v) == 'number' then
      -- vm = v - m
      -- sum = sum + (vm * vm)
      -- count = count + 1
    -- end
  -- end
  -- result = math.sqrt(sum / (count-1))
  -- return result
-- end

-- local function pack(...)
  -- return {...}
-- end

-- local function measure(name, func, report_frame_interval, resolution)
  -- report_frame_interval = report_frame_interval or 60
  -- resolution = resolution or "ms"
    -- measurings = measurings or {}
    -- measurings[name] = measurings[name] or {}
  -- local start = GameGetRealWorldTimeSinceStarted()
  -- local ret_vals = pack(func())
    -- table.insert(measurings[name], (GameGetRealWorldTimeSinceStarted() - start))
  -- if #measurings[name] >= report_frame_interval then
    -- local resolution_multiplier = resolution == "ms" and 1000 or (1000 * 1000)
    -- local longest = measurings[name]
    -- table.sort(longest)
    -- longest = longest[#longest]
    -- local sum = 0
    -- for i, v in ipairs(measurings[name]) do
      -- sum = sum + v
    -- end
    -- print(string.format("=== %s ===", name))
    -- print(string.format("All %d runs took %.2f%s", #measurings[name], sum * resolution_multiplier, resolution))
        -- print(string.format("Longest run took %.2f%s", longest * resolution_multiplier, resolution))
        -- print(string.format("Average run took %.2f%s", get_average(measurings[name]) * resolution_multiplier, resolution))
        -- print(string.format("Standard deviation %.2f%s", standardDeviation(measurings[name]) * resolution_multiplier, resolution))
        -- measurings[name] = {}
  -- end
  -- return unpack(ret_vals)
-- end

-- measure("Wang tile overlaying", function()
-- Put all your wang replacing code in here

setting_cache = setting_cache or {}
local function get_setting(name)
    setting_cache[name] = setting_cache[name] or ModSettingGet(name)
    return setting_cache[name]
end

function overlayNonTransparentPixels(source_path, target_path)
	local sourceId, sourceWidth, sourceHeight = ModImageMakeEditable(source_path, 0, 0)
	local targetId, targetWidth, targetHeight = ModImageMakeEditable(target_path, 0, 0)
	if sourceId ~= 0 and targetId ~= 0 then
		local width = math.min(sourceWidth, targetWidth)
		local height = math.min(sourceHeight, targetHeight)
		for y = 0, height - 1 do
			for x = 0, width - 1 do
				local sourceColor = ModImageGetPixel(sourceId, x, y)
				local alpha = bit.rshift(bit.band(sourceColor, 0xFF000000), 24) -- Extract alpha channel
				if alpha > 0 then
					ModImageSetPixel(targetId, x, y, sourceColor)
				end
			end
		end
	end
end


if get_setting("commonifier.trailer_scenes_enabled") then
	overlayNonTransparentPixels("mods/commonifier/data/wang_tiles/fungicave_overlay.png", "data/wang_tiles/fungicave.png")
	overlayNonTransparentPixels("mods/commonifier/data/wang_tiles/snowcave_overlay.png", "data/wang_tiles/snowcave.png")
	overlayNonTransparentPixels("mods/commonifier/data/wang_tiles/rainforest_overlay.png", "data/wang_tiles/rainforest.png")
	overlayNonTransparentPixels("mods/commonifier/data/wang_tiles/rainforest_open_overlay.png", "data/wang_tiles/rainforest_open.png")
	overlayNonTransparentPixels("mods/commonifier/data/wang_tiles/vault_overlay.png", "data/wang_tiles/vault.png")
end
-- end, 1, "ms")

--Setting custom probabilities to each biome scenes:
local coalmine_prob = math.floor(get_setting("commonifier.coalmine_multiplier") + 0.5)
if coalmine_prob < 7 then
	overlayNonTransparentPixels("mods/commonifier/data/wang_tiles/coalmine_mo" .. tostring(7 - coalmine_prob) .. ".png", "data/wang_tiles/coalmine.png")
end

local coalmine_alt_prob = math.floor(get_setting("commonifier.coalmine_alt_multiplier") + 0.5)
if coalmine_alt_prob < 5 then
	overlayNonTransparentPixels("mods/commonifier/data/wang_tiles/coalmine_alt_mo" .. tostring(5 - coalmine_prob) .. ".png", "data/wang_tiles/coalmine_alt.png")
end

local excavationsite_prob = math.floor(get_setting("commonifier.excavationsite_multiplier") + 0.5)
if excavationsite_prob < 9 then
	overlayNonTransparentPixels("mods/commonifier/data/wang_tiles/excavationsite_mo" .. tostring(9 - excavationsite_prob) .. ".png", "data/wang_tiles/excavationsite.png")
end

local snowcave_prob = math.floor(get_setting("commonifier.snowcave_multiplier") + 0.5)
if snowcave_prob < 5 then
	overlayNonTransparentPixels("mods/commonifier/data/wang_tiles/snowcave_mo" .. tostring(5 - snowcave_prob) .. ".png", "data/wang_tiles/snowcave.png")
end

local snowcastle_prob = math.floor(get_setting("commonifier.snowcastle_multiplier") + 0.5)
if snowcastle_prob < 7 then
	overlayNonTransparentPixels("mods/commonifier/data/wang_tiles/snowcastle_mo" .. tostring(7 - snowcastle_prob) .. ".png", "data/wang_tiles/snowcastle.png")
end

local rainforest_prob = math.floor(get_setting("commonifier.rainforest_multiplier") + 0.5)
if rainforest_prob < 5 then
	overlayNonTransparentPixels("mods/commonifier/data/wang_tiles/rainforest_mo" .. tostring(5 - rainforest_prob) .. ".png", "data/wang_tiles/rainforest.png")
end

if rainforest_prob < 5 then
	overlayNonTransparentPixels("mods/commonifier/data/wang_tiles/rainforest_open_mo" .. tostring(5 - rainforest_prob) .. ".png", "data/wang_tiles/rainforest_open.png")
end

local vault_prob = math.floor(get_setting("commonifier.vault_multiplier") + 0.5)
if vault_prob < 5 then
	overlayNonTransparentPixels("mods/commonifier/data/wang_tiles/vault_mo" .. tostring(5 - vault_prob) .. ".png", "data/wang_tiles/vault.png")
end

local crypt_prob = math.floor(get_setting("commonifier.crypt_multiplier") + 0.5)
if crypt_prob < 7 then
	overlayNonTransparentPixels("mods/commonifier/data/wang_tiles/crypt_mo" .. tostring(7 - crypt_prob) .. ".png", "data/wang_tiles/crypt.png")
end

ModLuaFileAppend( "data/scripts/biomes/fungicave.lua", "data/scripts/biomes/fungicave_commonifier.lua" )
ModLuaFileAppend( "data/scripts/biomes/rainforest.lua", "data/scripts/biomes/rainforest_commonifier.lua" )
ModLuaFileAppend( "data/scripts/biomes/coalmine.lua", "data/scripts/biomes/coalmine_commonifier.lua" )
ModLuaFileAppend( "data/scripts/biomes/coalmine_alt.lua", "data/scripts/biomes/coalmine_alt_commonifier.lua" )
ModLuaFileAppend( "data/scripts/biomes/pyramid.lua", "data/scripts/biomes/pyramid_commonifier.lua" )
ModLuaFileAppend( "data/scripts/biomes/excavationsite.lua", "data/scripts/biomes/excavationsite_commonifier.lua" )
ModLuaFileAppend( "data/scripts/biomes/snowcave.lua", "data/scripts/biomes/snowcave_commonifier.lua" )
ModLuaFileAppend( "data/scripts/biomes/snowcastle.lua", "data/scripts/biomes/snowcastle_commonifier.lua" )
ModLuaFileAppend( "data/scripts/biomes/vault.lua", "data/scripts/biomes/vault_commonifier.lua" )
ModLuaFileAppend( "data/scripts/biomes/crypt.lua", "data/scripts/biomes/crypt_commonifier.lua" )

