dofile("data/scripts/lib/mod_settings.lua")

function mod_setting_change_callback( mod_id, gui, in_main_menu, setting, old_value, new_value  )
	print( tostring(new_value) )
end

local mod_id = "commonifier"
mod_settings_version = 1
mod_settings = 
{
  {
    id = "unused_scenes_enabled",
    ui_name = "Unused Scenes",
    ui_description = "Toggle Unused Scenes on and off",
    value_default = true,
    scope = MOD_SETTING_SCOPE_RUNTIME,
  },
  {
    id = "trailer_scenes_enabled",
    ui_name = "Trailer Scenes",
    ui_description = "Toggles Trailer Scenes on and off.",
    value_default = true,
    scope = MOD_SETTING_SCOPE_NEW_GAME,
  },
  
	{
	  id = "coalmine_multiplier",
	  ui_name = "Mines",
	  ui_description = "Spawn probability of rare scenes",
	  value_default = 7,
	  value_min = 1,
	  value_max = 7,
	  value_display_multiplier = 1,
	  value_display_formatting = " $0 Probability",
	  scope = MOD_SETTING_SCOPE_NEW_GAME,
	},
	
	{
	  id = "coalmine_alt_multiplier",
	  ui_name = "Collapsed Mines",
	  ui_description = "Spawn probability of rare scenes",
	  value_default = 5,
	  value_min = 1,
	  value_max = 5,
	  value_display_multiplier = 1,
	  value_display_formatting = " $0 Probability",
	  scope = MOD_SETTING_SCOPE_NEW_GAME,
	},

	{
	  id = "excavationsite_multiplier",
	  ui_name = "Coal Pits",
	  ui_description = "Spawn probability of rare scenes",
	  value_default = 8,
	  value_min = 1,
	  value_max = 8,
	  value_display_multiplier = 1,
	  value_display_formatting = " $0 Probability",
	  scope = MOD_SETTING_SCOPE_NEW_GAME,
	},
	
	{
	  id = "snowcave_multiplier",
	  ui_name = "Snowy Depths",
	  ui_description = "Spawn probability of rare scenes",
	  value_default = 5,
	  value_min = 1,
	  value_max = 5,
	  value_display_multiplier = 1,
	  value_display_formatting = " $0 Probability",
	  scope = MOD_SETTING_SCOPE_NEW_GAME,
	},
	{
	  id = "snowcastle_multiplier",
	  ui_name = "Hiisi Base",
	  ui_description = "Spawn probability of rare scenes",
	  value_default = 7,
	  value_min = 1,
	  value_max = 7,
	  value_display_multiplier = 1,
	  value_display_formatting = " $0 Probability",
	  scope = MOD_SETTING_SCOPE_NEW_GAME,
	},
	{
	  id = "rainforest_multiplier",
	  ui_name = "Jungle",
	  ui_description = "Spawn probability of rare scenes",
	  value_default = 5,
	  value_min = 1,
	  value_max = 5,
	  value_display_multiplier = 1,
	  value_display_formatting = " $0 Probability",
	  scope = MOD_SETTING_SCOPE_NEW_GAME,
	},
	{
	  id = "vault_multiplier",
	  ui_name = "Vault",
	  ui_description = "Spawn probability of rare scenes",
	  value_default = 5,
	  value_min = 1,
	  value_max = 5,
	  value_display_multiplier = 1,
	  value_display_formatting = " $0 Probability",
	  scope = MOD_SETTING_SCOPE_NEW_GAME,
	},
	{
	  id = "crypt_multiplier",
	  ui_name = "Temple Of The Art",
	  ui_description = "Spawn probability of rare scenes",
	  value_default = 7,
	  value_min = 1,
	  value_max = 7,
	  value_display_multiplier = 1,
	  value_display_formatting = " $0 Probability",
	  scope = MOD_SETTING_SCOPE_NEW_GAME,
	},
}

function ModSettingsUpdate( init_scope )
	local old_version = mod_settings_get_version( mod_id )
	mod_settings_update( mod_id, mod_settings, init_scope )
end

function ModSettingsGuiCount()
	return mod_settings_gui_count( mod_id, mod_settings )
end

function ModSettingsGui( gui, in_main_menu )
	mod_settings_gui( mod_id, mod_settings, gui, in_main_menu )
end
